/*  dirclean.c
 *  program to truncate records to 12 chars,
 *  close up spaces, and set to lowercase.
 */

/*  function:  on xenix pc, the doscp command cannot
 *  use wild cards for copying files from msdos discs into
 *  the xenix file system.  as a workaround, one can obtain
 *  a directory of the files in a disc directory and route
 *  this output to a file.  this program can then read the
 *  previous output, writing a command for each listed filename.
 */

#include <stdio.h>
#include <ctype.h>
#define NEWLINE '\n'
#define BLANK ' '

main(argc, argv)
int argc;
char *argv[] ;

{
	long i=0L;     /* current column no */
	long j;
	int c;

	FILE  *fopen(),
	      *fp ,
	      *fpout  ;
	char filename[13] ;
	char dumyfile[13] ;
	char prefix[13] ;
	char suffix[13] ;

	prefix[0] = NULL ;
	suffix[0] = NULL ;
	dumyfile[0]  = 'd' ;
	dumyfile[1]  = 'u' ;
	dumyfile[2]  = 'm' ;
	dumyfile[3]  = 'y' ;
	dumyfile[4]  = 'f' ;
	dumyfile[5]  = 'i' ;
	dumyfile[6]  = 'l' ;
	dumyfile[7]  = 'e' ;
	dumyfile[8]  = '\0' ;


	if ( argc <  2)
		{
		fprintf(stderr, "Usage:  %s  <file to clean>\n",argv[0]);
		fprintf(stderr, "Usage:  %s  <file to clean> <prefix>\n",argv[0]);
		fprintf(stderr, "Usage:  %s  <file to clean> <prefix> <suffix>\n",argv[0]);
		fprintf(stderr, "Usage:  %s  <file to clean> \"doscp a:/\" .<--period\n",argv[0]);
		fprintf(stderr, "Exiting.\n");
		exit();
		}

	strcpy(filename, argv[1] );

	/* test existence of input file, and open it */

	if  ( ( fp   = fopen(  filename  , "r+" ) ) == NULL )
		{
		fprintf(stderr, "\nCannot open %s.\n", filename );
		exit(1);
		}
		fprintf(stderr, "opening %s\n", filename);

	fpout   =  fopen( dumyfile   , "w"  )  ;


	/* if prefix has been specified, use it */
	if (argc > 2 )
		{
		strcpy(prefix,   argv[2] );
		}

	/* if suffix has been specified, use it */
	if (argc > 3 )
		{
		strcpy(suffix,   argv[3] );
		}


	while ( (c=getc(fp)) != EOF  )
		{
		if (c != NEWLINE )
			{
			i++ ;

			if (i==1)
				{
				if (prefix[0] != NULL)
					{
					fprintf(fpout, "%s", prefix) ;
					}
				}
			if (isupper(c)) c = tolower(c) ;
			if (i==9) c = '.' ;
			if (!(isspace(c)) && (i<=12 ))  putc(c,fpout) ;
			/* fprintf (stderr, "i is %d\n",i) ;   */
			}
		else
			{
			i = 0 ;    /* reset column position counter */
			fprintf(fpout, " %s", suffix) ;
			putc(NEWLINE,fpout) ;
			}
		}
		/* unlink original file. */

	fclose(fp);
	fclose(fpout);

	/* unlink works in both turbo c and
	 * unix cc--remove works only in turbo c. */
	if (unlink( argv[1] ) == 0) 
		{
		}
	else
		{
		printf("\nThere was a problem deleting the original %s!\n",argv[1]);
		return(1);
		}
		

	/* this section replaces the rename function in xenix....*/

		 
	fp      =  fopen(  filename  , "w"  )  ; 
	fpout   =  fopen( dumyfile   , "r"  )  ;

	while ( (c=getc(fpout)) != EOF  )
		{
		putc(c,fp) ;
		}

		/* unlink dummy    file. */

	fclose(fp);
	fclose(fpout);

	/* unlink works in both turbo c and
	 * unix cc--remove works only in turbo c. */
	if (unlink( dumyfile ) == 0) 
		{
		}
	else
		{
		printf("\nThere was a problem deleting the dummy file!\n");
		return(1);
		}
		
	/* end of rename replacement....*/

	/* this section does not work in xenix...
	 *if (rename(dumyfile   , argv[1]) == 0)
	 *	return(0);
	 *else
	 *	{
	 *	printf("\nThere was a problem renaming the dummy file to %s!\n",argv[1]);
	 *	return(1);
	 *	}
	 */
}
